
package org.omegahat.DataStructures.Data.Viewers;

import org.omegahat.DataStructures.Data.VariableInt;
import org.omegahat.DataStructures.Data.FactorInt;


/**
  Internal model used for relating the contents
  of a {@link org.omegahat.DataStructures.Data.DataFrameInt DataFrameInt}
  to a {@link DataFrameViewer DataFrameViewer}.
*/
public class DataFrameTableModel  
        extends javax.swing.table.AbstractTableModel
{
protected org.omegahat.DataStructures.Data.DataFrameInt dataFrame;


public DataFrameTableModel() {

}

public DataFrameTableModel(org.omegahat.DataStructures.Data.DataFrameInt dataFrame) {
 dataFrame(dataFrame);
}



public int getRowCount() {
  int val= (int) dataFrame().numObservations();
  System.err.println("Num of rows " + val);
 return(val);
}

public int getColumnCount() {
  int cols = (int)dataFrame().numVariables();
  System.err.println("Num of cols " + cols);
   return(cols);
}

public Object getValueAt(int row, int col) {
 VariableInt var =  getVariable(col); 
 return( var.value(row) );
}


public String getColumnName(int whichColumn) {
 String name =  dataFrame().getVariableNames()[whichColumn];
 System.err.println("Variable name " + whichColumn + " " + name);
 return(name);
}

public Class getColumnClass(int which) {
 VariableInt var = getVariable(which);

  if(var instanceof FactorInt) {
    return(String.class);
  }
  else
    return(Number.class);
}

public int findColumn(String columnName) {
  String[] names = dataFrame().getVariableNames();
  for(int i = 0; i < names.length; i ++) {
    if(names[i].equals(columnName)) {
      System.err.println(columnName + " -> " + i);
      return(i);
    }
  }

 return(-1);
}


public boolean isCellEditable(int row, int column) {
 return(true);
}

public org.omegahat.DataStructures.Data.VariableInt getVariable(int whichColumn) {
 org.omegahat.DataStructures.Data.VariableInt var = dataFrame().getVariable(getColumnName(whichColumn));
 System.err.println("Variable " + whichColumn + " "+var);
 return(var);
}


public org.omegahat.DataStructures.Data.DataFrameInt dataFrame()
{
   return(dataFrame);
}

public org.omegahat.DataStructures.Data.DataFrameInt dataFrame(org.omegahat.DataStructures.Data.DataFrameInt value)
{
   dataFrame = value;
  return(dataFrame);
}



}

/*
Copyright (c) 1998 1999, The Omega Project for Statistical Computing.
     All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions are
     met:

       Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

       Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

       Neither name of the Omega Project for Statistical Computing nor the 
       names of its contributors may be used to endorse or promote products 
       derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY
     EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
     SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
     PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
     INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
     STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
     THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

*/

